import * as Mqtt from 'mqtt'
import * as Mongo from 'mongodb'


var MQTT_BROKER_URL : String = 'mqtt://localhost'
var MONGO_DATABASE_URL : String = 'mongodb://localhost/test'


class MqttMongo {
  private mqttClient : Mqtt.Client
  private dbHandle : Mongo.Db;
  private msgCnt : number = 0;

  constructor() {
    this.mqttClient = Mqtt.connect(options['broker'])
    this.mqttClient.on('offline', () => { console.log("mqtt client is offline") })
    this.mqttClient.on('reconnect', () => { console.log("mqtt client is reconnecting") })
    this.mqttClient.on('close', () => { console.log("mqtt connection closed") })

/*
    Mongo.MongoClient.connect(options['database'])
      .then(
        (dbHandle: Mongo.Db) => { this.dbHandle = dbHandle },
        (err: String) => {
          console.log("Unable to connect to database: %s", err)
          process.exit(1)
        }
    )
*/
  }

  exec(): void {
    this.mqttClient.on('connect', () => {
      console.log("mqtt client connected to broker")
      this.mqttClient.subscribe('MqttMongo/Command')
      this.mqttClient.publish('MqttMongo/Status', 'hello, started up')
    })

    this.mqttClient.on('message', (topic : string, message : string) => {
      this.msgCnt++;
      console.log(`message received ${this.msgCnt}, topic ${topic}, payload ${message}`)

      if (topic == "MqttMongo/Command" && message == "shutdown") {
        this.mqttClient.end()
      } else {
        // verify JSON format of message
        // insert into database
      }
    })
  }
}


import options = require('commander')
options
  .version('0.0.1')
  .option('-b, --broker [broker url]', 'Broker URL', MQTT_BROKER_URL)
  .option('-m, --database [database url]', 'MongoDB Database URL', MONGO_DATABASE_URL)
  .parse(process.argv)

const mqttMongo = new MqttMongo()
mqttMongo.exec()

console.log("MqttMongo started")